﻿/*
 * Created by SharpDevelop.
 * User: simpsont
 * Date: 24/01/2010
 * Time: 8:50 AM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
 
 // Copyright (c) Troy Simpson 2007

// DISCLAIMER
// I will not be held responsible for any damage arising from
// an incorrect/faulty installation or bugs in this software.  
// It is your responsibility to test this software and ensure 
// it works as expected, and to monitor the installation for
// faults.
//
// I am using this software to control watering in my own yard
// so I have endeavoured to make it as stable and reliable as
// possible.


// With thanks from http://logix4u.net/ for the inpout32.dll
// and to Levent Saltuklaroglu for the article on 
// controlling LED's here:
// http://www.codeproject.com/csharp/csppleds.asp
// and to phebejtsov for the article on reading from the parallel port here:
// http://www.codeproject.com/useritems/Inpout32_read.asp
// and to cucgachthe for the FindControl function here:
// http://www.codeproject.com/Purgatory/getControlFromName.asp?df=100&forumid=57432&select=975781#xx975781xx

using Microsoft.VisualBasic;
using System;
using System.Data;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Reflection;
using System.ComponentModel;
using System.Text;
using System.Security;
using System.Security.Principal;
using OpenLibSys;

namespace ezSprinkle
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class ezSprinkle : Form
	{
        //private ushort address = 0x3BC;
		private byte mastervalue = 0;
        Ols ols;

		public ezSprinkle()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
            setEvents();
        }
		
		void ezSprinkleLoad(object sender, EventArgs e)
		{
            if (!IsAdmin())
            {
                RunAsRestart();
                Environment.Exit(0);
            }
            CenterToScreen();
            InitIO();
            RunezSprinkle();
        }

        void RunezSprinkle()
        {
			Application.EnableVisualStyles();

            ols = new Ols(); // initialise our IO class

			// persist properties
			if (File.Exists(Util.cwd() + "ezSprinkle.xml")) {
				dsSprinkle.ReadXml(Util.cwd() + "ezSprinkle.xml");
			}

			// make sure auto sprinkle has a row
			try {
				if (dsSprinkle.Tables["Startup"].Rows.Count == 0) {
					System.Data.DataRow dr = null;

					dr = dsSprinkle.Tables["Startup"].Rows.Add();
					dsSprinkle.AcceptChanges();
				}
			} catch (Exception ex) {
				MessageBox.Show("You can't add an Area with the same number as an existing Area.");
			}

			object obj = null;
			int i = 0;
			int x = 0;

			// perform a first-time time clash check
			for (i = 1; i <= 2; i++) {
				for (x = 1; x <= 4; x++) {
					obj = Util.FindControl(this, "udwk" + i + "Duration" + x);
					CheckTimeClashUD(obj, null);
				}
			}

            if (txtPortAddr.Text == "")
                txtPortAddr.Text = "3BC";

            cboArea.DataSource = dsSprinkle.Tables["Area"];
            cboArea.DisplayMember = dsSprinkle.Tables["Area"].Columns["AreaName"].ToString();
            cboArea.ValueMember = dsSprinkle.Tables["Area"].Columns["AreaNum"].ToString();

            timMaster.Start();
        }
		
		void ezSprinkleFormClosing(object sender, FormClosingEventArgs e)
		{
            // don't try to save settings on closing, this has been problematic in zero-lengthing the settings xml
            return;

            save();
		}
		
		void save() {
            // try to avoid a bug where an empty schema is written, overwriting the schedule
            if (dsSprinkle.Tables[0].Rows.Count == 0)
                return;

			try {
                // backup settings
                try
                {
                    // do this separately - if it is in the same try-catch as the copy to backup,
                    // the backup will never occur because it will always fail at this point on first
                    // go
                    File.Delete(Util.cwd() + "ezSprinkle.bak");
                }
                catch
                {
                    // ignore file not exist error
                }

				try {
					File.Copy(Util.cwd() + "ezSprinkle.xml", Util.cwd() + "ezSprinkle.bak");
				} catch {
                    // ignore file not exist error
                }

				// persist properties
				dsSprinkle.WriteXml(Util.cwd() + "ezSprinkle.xml", XmlWriteMode.WriteSchema);
			} catch (Exception ex) {
				MessageBox.Show(ex.Message);
			}
		}
		
		void BtnSaveClick(object sender, EventArgs e)
		{
			save();
		}
		
		// Makes all the data pins low so the relays turn off
		private void Reset_Relays()
		{
			ols.WriteIoPortByte(PortAddr, 0);
		}

		// master control timer - always stays enabled
		void TimMasterTick(object sender, EventArgs e)
		{
			// set the relays so long as a program is not midway being set
			if (!setting_program) {
                ols.WriteIoPortWord(PortAddr, mastervalue);
			}

			if (string.IsNullOrEmpty(grpArea.Text)) {
				grpArea.Enabled = false;
			} else {
				grpArea.Enabled = true;
			}

			GetRainSensorStatus();

			lblWeekNum.Text = "Week " + getWeekNumber();

			// And Not chkRain.Checked Then
			if (chkAuto.Checked && bsArea.Count > 0) {
				AutoRun();
			}
		}

		// is it raining?

        /// <summary>
        /// Get rain sensor status and use the resulting value to determine whether to run a program.
        /// Rain sensor is attached to GND pin 25 and IN pin 13.
        /// </summary>
		private void GetRainSensorStatus()
		{
            // NOTE, that rain sensor's are usually NORMALLY CLOSED
            byte Value1 = ols.ReadIoPortByte((ushort)(PortAddr + 0x1)); // the first input pair
            // pin 13 is bit 4 of the input value (parallel port D4), which has a value of 0x10 in hex
            if (((0x10 & Value1) == 0x10) == chkSenseNO.Checked)
            {
                chkRain.Checked = true;
                // raining
                mastervalue = 0;
            }
            else
            {
                chkRain.Checked = false;
            }

			lblIn.Text = Value1.ToString();
		}
		

		// make sure the relays don't flick on && off whilst we are running the 
		// program because the master timer may intervene partway through
		// the calculations
		bool setting_program = false;
		
		// run the watering programs
		private void AutoRun()
		{
			int i = 0;
			int x = 0;
			string wk = "wk" + getWeekNumber();
			System.DateTime dt1 = default(System.DateTime);
			System.DateTime dt2 = default(System.DateTime);
			bool auto_flag = false;
			System.DateTime nowtime = Convert.ToDateTime(Strings.Format(DateAndTime.Now, "HH:mm"));
			string currday = Strings.Format(DateAndTime.Now, "ddd");

			setting_program = true;

			mastervalue = 0;

			if (bsArea.Count == 0) {
				setting_program = false;

				return;
			}

			// loop the areas		
			for (i = 0; i <= bsArea.Count - 1; i++) {
				System.Data.DataRowView drv = (System.Data.DataRowView)bsArea.List[i];
				
				// check if we're watering today
				if (Convert.ToBoolean(drv.Row[wk + currday]) && Convert.ToBoolean(drv.Row["Active"])) {
					if ((!Convert.ToBoolean(drv.Row["RainSense"])) | (!chkRain.Checked)) {
						for (x = 1; x <= 4; x++) {
							// work with each of the four time programs
							if (Convert.ToInt32(drv.Row[wk + "Duration" + x]) > 0) {
								// check if this program should be running
								dt1 = Convert.ToDateTime(Strings.Format(drv.Row[wk + "StartTime" + x], "HH:mm"));
								dt2 = Convert.ToDateTime(DateAndTime.DateAdd(DateInterval.Minute, Convert.ToInt32(drv.Row[wk + "Duration" + x]), dt1));

								// check if inside the program time
								if (nowtime >= dt1 && nowtime < dt2) {
									CloseAutoRelays(i);

									stLabel.Text = "Watering " + drv.Row["AreaName"].ToString() + " - " + drv.Row[wk + "Duration" + x].ToString() + " mins.  " + DateAndTime.DateDiff(DateInterval.Minute, nowtime, dt2, FirstDayOfWeek.Sunday, FirstWeekOfYear.Jan1).ToString() + " mins remain";
									auto_flag = true;
								}
							}
						}
					}
				}
			}

			if (!auto_flag) {
				mastervalue = 0;
				stLabel.Text = "ezSprinkle";
			}

			setting_program = false;
		}

		// an automatic program is set to run, so run it
		private void CloseAutoRelays(int auto_area)
		{
			int x = 0;
			System.Data.DataRowView drv = (System.Data.DataRowView)bsArea.List[auto_area];

			// iterate the relay selections for the selected area
			for (x = 1; x <= 8; x++) {
				if (Convert.ToBoolean(drv.Row["Relay" + x])) {
					mastervalue = (byte)(mastervalue | (ushort)(Math.Pow(2, x - 1)));
				}
			}
		}

		// uses a modulus of week of year to toggle between week 1 && 2
		private int getWeekNumber()
		{
			return (DateAndTime.DatePart("ww", DateAndTime.Now, FirstDayOfWeek.Sunday, FirstWeekOfYear.Jan1) % 2) + 1;
		}

		void ChkAllOffCheckedChanged(object sender, EventArgs e)
		{
			// All off, so cancel everything
			if (chkAllOff.Checked) {
				chkAuto.Checked = false;
				chkAuto.Enabled = false;
				BtnCancelManualClick(null, null);
				grpManual.Enabled = false;
			} else {
				chkAuto.Enabled = true;
				grpManual.Enabled = true;
			}

			EnableManualStart(null, null);
		}
		
		void ChkAutoCheckedChanged(object sender, EventArgs e)
		{
			if (chkAuto.Checked) {
				BtnCancelManualClick(null, null);
				grpManual.Enabled = false;
			} else {
				grpManual.Enabled = true;
				EnableManualStart(null, null);
				// don't inadvertantly enable the start button
				mastervalue = 0;
			}
		}
		
		void MtbCopyToTextChanged(object sender, EventArgs e)
		{
			if (!string.IsNullOrEmpty(mtbCopyTo.Text)) {
				btnAreaCopy.Enabled = true;
			} else {
				btnAreaCopy.Enabled = false;
			}
        }

        #region "Manual Run"
        // enables the start button for a manual run
		private void EnableManualStart(object sender, System.EventArgs e)
		{
			if (CanRunManual()) {
				btnManualStart.Enabled = true;
			} else {
				btnManualStart.Enabled = false;
			}
		}

		// checks whether enough information has been given to run a manual time
		private bool CanRunManual()
		{
			if ((chkManual1.Checked | chkManual2.Checked | chkManual3.Checked | chkManual4.Checked | chkManual5.Checked | chkManual6.Checked | chkManual7.Checked | chkManual8.Checked) && nudManual.Value > 0 && !chkAllOff.Checked) {
				return true;
			}

			return false;
		}

		// manual run
		private DateTime stTime;

		void BtnManualStartClick(object sender, EventArgs e)
		{
			btnManualStart.Enabled = false;
			btnCancelManual.Enabled = true;

			//Reset_Relays()
			ManualStart();
			stTime = DateAndTime.Now;
			timManual.Start();
		}
		
		void TimManualTick(object sender, EventArgs e)
		{
			timMaster.Stop();

			stLabel.Text = "Manual Run - " + ((nudManual.Value * 60) - DateAndTime.DateDiff(DateInterval.Second, stTime, DateAndTime.Now, FirstDayOfWeek.Sunday, FirstWeekOfYear.Jan1)).ToString() + " seconds remaining...";

			if (DateAndTime.DateDiff(DateInterval.Second, stTime, DateAndTime.Now, FirstDayOfWeek.Sunday, FirstWeekOfYear.Jan1) >= (nudManual.Value * 60)) {
				//Reset_Relays()
				mastervalue = 0;
				timManual.Stop();
				btnManualStart.Enabled = true;
				btnCancelManual.Enabled = false;
				timMaster.Start();
			}
		}
		
		// close the relays for a manual run
		private void ManualStart()
		{
			if (chkManual1.Checked) {
				mastervalue += Convert.ToByte(Math.Pow(2, 0));
			}
			//		mastervalue += 0

			if (chkManual2.Checked) {
                mastervalue += Convert.ToByte(Math.Pow(2, 1));
			}
			//		mastervalue += 0

			if (chkManual3.Checked) {
                mastervalue += Convert.ToByte(Math.Pow(2, 2));
			}
			//		mastervalue += 0

			if (chkManual4.Checked) {
                mastervalue += Convert.ToByte(Math.Pow(2, 3));
			}
			//		mastervalue += 0

			if (chkManual5.Checked) {
                mastervalue += Convert.ToByte(Math.Pow(2, 4));
			}
			//		mastervalue += 0

			if (chkManual6.Checked) {
                mastervalue += Convert.ToByte(Math.Pow(2, 5));
			}
			//		mastervalue += 0

			if (chkManual7.Checked) {
                mastervalue += Convert.ToByte(Math.Pow(2, 6));
			}
			//		mastervalue += 0

			if (chkManual8.Checked) {
                mastervalue += Convert.ToByte(Math.Pow(2, 7));
			}
			//		mastervalue += 0
		}
		
		void BtnCancelManualClick(object sender, EventArgs e)
		{
			mastervalue = 0;
			timManual.Stop();
			timMaster.Start();
			btnManualStart.Enabled = true;
			btnCancelManual.Enabled = false;
		}
#endregion

#region "New Area"
		// enable/disable addition of a new area depending on text entered
		// for the new area number field
		void TxtNewAreaNumTextChanged(object sender, EventArgs e)
		{
			if (!string.IsNullOrEmpty(txtNewAreaNum.Text)) {
				btnNewArea.Enabled = true;
			} else {
				btnNewArea.Enabled = false;
			}
		}

		void TxtNewAreaNumEnter(object sender, EventArgs e)
		{
			txtNewAreaNum.Focus();
			txtNewAreaNum.Text = txtNewAreaNum.Text;
			txtNewAreaNum.SelectAll();
		}
		
		void TxtNewAreaNumClick(object sender, EventArgs e)
		{
			TxtNewAreaNumEnter(null, null);
		}
		
		void BtnNewAreaClick(object sender, EventArgs e)
		{
			// ensure that any changes are written before we proceed
			dsSprinkle.AcceptChanges();

			try {
				System.Data.DataRow dr = null;

				dr = dsSprinkle.Tables["Area"].Rows.Add();
				dr["AreaNum"] = txtNewAreaNum.Text;
				dsSprinkle.AcceptChanges();
				txtNewAreaNum.Text = "";
				// go to the new record
				bsArea.Position = bsArea.Count;
			} catch (Exception ex) {
				MessageBox.Show("You can't add an Area with the same number as an existing Area.");
			}
		}
#endregion
		
		void BtnDupWeekClick(object sender, EventArgs e)
		{
			// day selection
			chkwk2Mon.Checked = chkwk1Mon.Checked;
			chkwk2Tue.Checked = chkwk1Tue.Checked;
			chkwk2Wed.Checked = chkwk1Wed.Checked;
			chkwk2Thu.Checked = chkwk1Thu.Checked;
			chkwk2Fri.Checked = chkwk1Fri.Checked;
			chkwk2Sat.Checked = chkwk1Sat.Checked;
			chkwk2Sun.Checked = chkwk1Sun.Checked;

			// duration
			udwk2Duration1.Value = udwk1Duration1.Value;
			udwk2Duration2.Value = udwk1Duration2.Value;
			udwk2Duration3.Value = udwk1Duration3.Value;
			udwk2Duration4.Value = udwk1Duration4.Value;

			// start times
			dtwk2Start1.Value = dtwk1Start1.Value;
			dtwk2Start2.Value = dtwk1Start2.Value;
			dtwk2Start3.Value = dtwk1Start3.Value;
			dtwk2Start4.Value = dtwk1Start4.Value;
		}
		
		void ChkRainCheckedChanged(object sender, EventArgs e)
		{
			LogRain();
		}
		
// data logging of the rainfall sensor
		private void LogRain()
		{
			string fname = "rainlog.log";

			if (chkRain.Checked) {
				using (StreamWriter w = File.AppendText(Util.cwd() + fname)) {
					w.WriteLine("Rain Sensor Activated: " + DateAndTime.Now);
					// Update the underlying file.
					w.Flush();
					w.Close();
				}
			} else {
				using (StreamWriter w = File.AppendText(Util.cwd() + fname)) {
					w.WriteLine("Rain Sensor De-Activated: " + DateAndTime.Now);
					// Update the underlying file.
					w.Flush();
					w.Close();
				}
			}
		}
		
		void BtnAreaCopyClick(object sender, EventArgs e)
		{
			System.Data.DataRow drold = null;
			System.Data.DataRow dr = null;
        	System.Data.DataRowView drv;

			// ensure that any changes are written before we proceed
			dsSprinkle.AcceptChanges();

	        drv = (System.Data.DataRowView)bsArea.Current;
			drold = drv.Row;

			try {
				int i = 0;
				int x = 0;

				dr = dsSprinkle.Tables["Area"].Rows.Add();
				dr["AreaNum"] = mtbCopyTo.Text;

				// copy all of the old columns to the new record
				for (i = 1; i <= drold.Table.Columns.Count - 1; i++) {
					// do not copy relay allocations
					if (Strings.InStr(Convert.ToString(drold.Table.Columns[i].ColumnName), "Relay", CompareMethod.Text) == 0 && Convert.ToString(drold.Table.Columns[i].ColumnName) != "AreaName") {
						dr[i] = drold[i];
					}
				}

				string wk = null;

				// Iterate the two weeks and the four programs in each week
				// to increment the start time in the new area to
				// complete the smart copy.
				// This helps to set area start/stop times back-to-back
				// without the inconvenience of having to manually schedule
				// each area.  If all areas are to operate for the same
				// duration back-to-back, then you only need to program the
				// first area, then smart copy to the new areas, change the
				// relay allocation and you're done.
				for (i = 1; i <= 2; i++) {
					wk = "wk" + i;

					for (x = 1; x <= 4; x++) {
						if (Convert.ToInt32(dr[wk + "Duration" + x]) != 0) {
							// add the duration to the start time so it can work back-to-back
							dr[wk + "StartTime" + x] = DateAndTime.DateAdd(DateInterval.Minute, Convert.ToInt32(dr[wk + "Duration" + x]), Convert.ToDateTime(dr[wk + "StartTime" + x]));
						}
					}
				}

				dsSprinkle.AcceptChanges();
				// go to the new record
				bsArea.Position = bsArea.Count;
			} catch (Exception ex) {
				dr.Delete();
				// Add failed, so delete the new record
				dsSprinkle.AcceptChanges();
				MessageBox.Show("You can't add an Area with the same number as an existing Area.");
			}

			mtbCopyTo.Text = "";
		}
		
		// highlight the copy to field on enter
		void MtbCopyToEnter(object sender, EventArgs e)
		{
			mtbCopyTo.Focus();
			mtbCopyTo.Text = mtbCopyTo.Text;
			mtbCopyTo.SelectAll();
		}
		
		// highlight the copy to field on click
		void MtbCopyToClick(object sender, EventArgs e)
		{
			MtbCopyToEnter(null, null);
		}
		
		// this is used to ensure the current row doesn't try to set twice
		bool navFlag = false;
		
		// this is our navigation combo
		
		void CboAreaSelectedIndexChanged(object sender, EventArgs e)
		{
			if (!navFlag) {
				navFlag = true;

                bsArea.Position = bsArea.Find("AreaNum", ((DataRowView)cboArea.SelectedItem)["AreaNum"]);
            }

			navFlag = false;
		}

		// sync the dropdownlist with the binding source
		
		void BindingSource1PositionChanged(object sender, EventArgs e)
		{
			int i = 0;
			System.Data.DataRow dr = null;

			if (!navFlag) {
				for (i = 0; i <= cboArea.Items.Count - 1; i++) {
	                System.Data.DataRowView drv = (System.Data.DataRowView)cboArea.Items[i];
					dr = drv.Row;

					// make sure the row we are examining has not been removed
					if (dr.RowState != DataRowState.Deleted && dr.RowState != DataRowState.Detached) {
	                    System.Data.DataRowView bsdrv = (System.Data.DataRowView)bsArea.Current;
						// find the matching item in the dropdown list
						if (Convert.ToInt16(drv.Row["AreaNum"]) == Convert.ToInt16(bsdrv.Row["AreaNum"])) {
							navFlag = true;
							cboArea.SelectedIndex = i;

							break;
						}
					}
				}
			}

			navFlag = false;
		}
		
		void BtnViewRainLogClick(object sender, EventArgs e)
		{
			Interaction.Shell("notepad " + Util.cwd() + "rainlog.log", AppWinStyle.NormalFocus, false, -1);
		}
		
		void LinkLabel1LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start("http://www.ebswift.com");
		}
		
		// this forces validation on nudManual by handling the textchanged event and setting its text to its value.
		// reading the value triggers validation when a value is manually typed.
		private void validatenudManual(System.Object sender, System.EventArgs e)
		{
			nudManual.Text = nudManual.Value.ToString();
		}

		// handler for checking for time clashes against the duration selectors
		// Key to this sub is the use of TextChanged.  TextChanged is not a selectable
		// event and it does not appear in intellisense, however it is usable.
		// Validations to valuechanged do not work if a value is typed, but validations
		// will occur if handled by textchanged.
		private void CheckTimeClashUD(System.Object sender, System.EventArgs e)
		{
			NumericUpDown tmpnud = (NumericUpDown)sender;

			// ensure that overtyping the value cannot take an invalid value
			tmpnud.Text = tmpnud.Value.ToString();

			if (bsArea.Position >= 0) {
	            Control ctl = (Control)sender;
				string wk = Strings.Mid(ctl.Name, 3, 3);
				int prgnum = Convert.ToInt16(Strings.Mid(ctl.Name, 14));

				// get the paired date time picker control
	            DateTimePicker dtp;
				dtp = (DateTimePicker)Util.FindControl(this, "dt" + wk + "Start" + prgnum);
	            DateTime dt = dtp.Value;
	
				CheckTimeClash(wk, prgnum, Convert.ToDateTime(dt.ToString("HH:mm")));
			}
		}

		// handler for checking for time clashes against the start time selectors
		private void CheckTimeClashDT(System.Object sender, System.EventArgs e)
		{
			if (bsArea.Position >= 0) {
	            DateTimePicker dtp = (DateTimePicker)sender;
				string wk = "wk" + Strings.Mid(dtp.Name, 5, 1);
				int prgnum = Convert.ToInt16(Strings.Mid(dtp.Name, 11));

				CheckTimeClash(wk, prgnum, Convert.ToDateTime(Strings.Format(dtp.Value, "HH:mm")));
			}
		}
		
		// check for time clashes if you activate/inactivate a day
		private void CheckTimeClashChk(object sender, EventArgs e)
		{
			if (bsArea.Position >= 0) {
				CheckBox chk = (CheckBox)sender;
				string wk = "wk" + Strings.Mid(chk.Name, 6, 1);

				// loop through the programs
				int i = 0;

				for (i = 1; i <= 4; i++) {
					DateTimePicker dtp = null;
					dtp = (DateTimePicker)Util.FindControl(this, "dt" + wk + "Start" + i.ToString());
					DateTime dt = dtp.Value;

					CheckTimeClash(wk, i, Convert.ToDateTime(dt.ToString("HH:mm")));
				}
			}
		}

		// checks a time clash against either the duration or the start time for a program
		// wk is the week taken from the sending object's name,
		// prgnum is the program number for the given week taken from the sending object's name,
		// dt1a is the start time which is sent by the sending object
		private void CheckTimeClash(string wk, int prgnum, System.DateTime dt1a)
		{
			System.DateTime dt2a = default(System.DateTime);
			// calculated time for end run time for the program that we are checking
			System.DateTime dt1b = default(System.DateTime);
			// start time of the compare program
			System.DateTime dt2b = default(System.DateTime);
			// end time of the compare program
			int i = 0;
			// iterator for week
			int x = 0;
			// iterator for program rows
			Control ctl = null;
			// worker object used to find the control name for any objects whose name we need to construct
			bool visFlag = false;
			// the flag used for displaying or hiding the clash message
			string strmsg = "";
			// the message indicating the clashed program
			int clashcnt = 0;
			// the number of counted clashes
			NumericUpDown nud = (NumericUpDown)Util.FindControl(this, "ud" + wk + "Duration" + prgnum.ToString());

			if (nud.Value > 0) {
				dt1a = Convert.ToDateTime(Strings.Format(dt1a, "HH:mm"));
				dt2a = DateAndTime.DateAdd(DateInterval.Minute, Convert.ToDouble(nud.Value), dt1a);

				// get the binary representation of the selected days on the current area
				System.Data.DataRowView drv1 = (System.Data.DataRowView)bsArea.Current;
				short binCurrentWeek = 0;
				// current area's week binary representation
				short binCompWeek = 0;
				// week to binary compare to for a different area
				string[] days = {
					"Sun",
					"Mon",
					"Tue",
					"Wed",
					"Thu",
					"Fri",
					"Sat"
				};
				int iday = 0;

				for (iday = 1; iday <= 7; iday++) {
					if (Convert.ToBoolean(drv1.Row[wk + days[iday - 1]])) {
						binCurrentWeek = Convert.ToInt16((binCurrentWeek | Convert.ToInt16(Math.Pow(2, iday))));
					}
				}

				// on form load, rows.count = 1 - this is a bug
				int rc = bsArea.Count;
				for (i = 0; i <= bsArea.Count - 1; i++) {
					if (i != bsArea.Position) {
						System.Data.DataRowView drv = (System.Data.DataRowView)bsArea.List[i];
						binCompWeek = 0;

						for (iday = 1; iday <= 7; iday++) {
							// get the binary representation of the compare week
							if (Convert.ToBoolean(drv.Row[wk + days[iday - 1]])) {
								binCompWeek = Convert.ToInt16((binCompWeek | Convert.ToInt16(Math.Pow(2, iday))));
							}
						}

						// only check for clashes if a same day has been selected
						// for two areas
						if ((binCurrentWeek & binCompWeek) > 0) {
							for (x = 1; x <= 4; x++) {
								// don't compare with self or zero valued durations
								if ((i != bsArea.Position | x != prgnum) && Convert.ToInt16(drv.Row[wk + "Duration" + x.ToString()]) != 0) {
									dt1b = Convert.ToDateTime(Strings.Format(drv.Row[wk + "StartTime" + x], "HH:mm"));
									dt2b = Convert.ToDateTime(DateAndTime.DateAdd(DateInterval.Minute, Convert.ToInt32(drv.Row[wk + "Duration" + x]), dt1b));

									if (TimesOverlap(dt1a, dt2a, dt1b, dt2b)) {
										// set the alert message to be the first encountered clash
										// otherwise it will be set to the last
										if (!visFlag) {
											strmsg = "*Area" + Convert.ToInt16(drv.Row["AreaNum"]).ToString() + " Wk" + Strings.Mid(wk, 3, 1) + " Prg" + x.ToString();
										}

										visFlag = true;
										clashcnt += 1;
									}
								}
							}
						}
					}
				}
			}

			// indicate in the alert message that there is more than one clash
			// our label is only big enough to show the details of one clash
			// at a time
			if (clashcnt > 1) {
				strmsg += "+";
			}

			// set the alert message - will not display if there is no clash
			ctl = (Control)Util.FindControl(this, "lbl" + wk + "Prog" + prgnum.ToString() + "Alert");
			ctl.Text = strmsg;
			ctl.Visible = visFlag;
		}
		
		private bool TimesOverlap(System.DateTime dt1a, System.DateTime dt2a, System.DateTime dt1b, System.DateTime dt2b)
		{
			// take a minute off end dates so as not to confuse the issue -
			// technically the end time and start time of any back-to-back
			// programs will fall within the same second
			dt2a = DateAndTime.DateAdd(DateInterval.Minute, -1, dt2a);
			dt2b = DateAndTime.DateAdd(DateInterval.Minute, -1, dt2b);

			if ((dt1a <= dt1b && dt2a >= dt1b) | (dt1a >= dt1b && dt1a <= dt2b)) {
				return true;
			}

			return false;
		}

        /// <summary>
        /// LPT Port Address
        /// </summary>
        private ushort PortAddr {
            get { return (ushort)Convert.ToUInt16(txtPortAddr.Text, 16); }
            set { txtPortAddr.Text = value.ToString(); }
        }

        private void ezSprinkle_Resize(object sender, EventArgs e)
        {
            if (FormWindowState.Minimized == this.WindowState)
            {
                notifyIcon1.Visible = true;
                notifyIcon1.ShowBalloonTip(500);
                this.Hide();
            }
            else if (FormWindowState.Normal == this.WindowState)
            {
                notifyIcon1.Visible = false;
            }
        }

        private void notifyIcon1_Click(object sender, EventArgs e)
        {
            this.Show();
            this.WindowState = FormWindowState.Normal;
        }
	}
}

namespace ezSprinkle
{
	public class Util
	{
// current working directory
		public static string cwd()
		{
			return Application.StartupPath + "\\";
		}

		// cucgachthe's FindControl function from here:
		// http://www.codeproject.com/Purgatory/getControlFromName.asp?df=100&forumid=57432&select=975781#xx975781xx
		public static Control FindControl(ezSprinkle Caller, string Name)
		{
            return (Control)Caller.Controls.Find(Name, true)[0];
        }
	}
}

